<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>OpResult.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">OpResult.java</span></div><h1>OpResult.java</h1><pre class="source lang-java linenums">/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the &quot;License&quot;); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;


import org.apache.zookeeper.data.Stat;

/**
 * Encodes the result of a single part of a multiple operation commit.
 */
public abstract class OpResult {
    private int type;

<span class="fc" id="L29">    private OpResult(int type) {</span>
<span class="fc" id="L30">        this.type = type;</span>
<span class="fc" id="L31">    }</span>

    /**
     * Encodes the return type as from ZooDefs.OpCode.  Can be used
     * to dispatch to the correct cast needed for getting the desired
     * additional result data.
     * @see ZooDefs.OpCode
     * @return an integer identifying what kind of operation this result came from.
     */
    public int getType() {
<span class="fc" id="L41">        return type;</span>
    }

    /**
     * A result from a create operation.  This kind of result allows the
     * path to be retrieved since the create might have been a sequential
     * create.
     */
    public static class CreateResult extends OpResult {
        private String path;

        public CreateResult(String path) {
<span class="fc" id="L53">            super(ZooDefs.OpCode.create);</span>
<span class="fc" id="L54">            this.path = path;</span>
<span class="fc" id="L55">        }</span>

        public String getPath() {
<span class="fc" id="L58">            return path;</span>
        }

        @Override
        public boolean equals(Object o) {
<span class="fc bfc" id="L63" title="All 2 branches covered.">            if (this == o) return true;</span>
<span class="fc bfc" id="L64" title="All 2 branches covered.">            if (!(o instanceof CreateResult)) return false;</span>

<span class="fc" id="L66">            CreateResult other = (CreateResult) o;</span>
<span class="pc bpc" id="L67" title="1 of 4 branches missed.">            return getType() == other.getType() &amp;&amp; path.equals(other.getPath());</span>
        }

        @Override
        public int hashCode() {
<span class="fc" id="L72">            return getType() * 35 + path.hashCode();</span>
        }
    }

    /**
     * A result from a delete operation.  No special values are available.
     */
    public static class DeleteResult extends OpResult {
        public DeleteResult() {
<span class="fc" id="L81">            super(ZooDefs.OpCode.delete);</span>
<span class="fc" id="L82">        }</span>

        @Override
        public boolean equals(Object o) {
<span class="fc bfc" id="L86" title="All 2 branches covered.">            if (this == o) return true;</span>
<span class="fc bfc" id="L87" title="All 2 branches covered.">            if (!(o instanceof DeleteResult)) return false;</span>

<span class="fc" id="L89">            DeleteResult opResult = (DeleteResult) o;</span>
<span class="pc bpc" id="L90" title="1 of 2 branches missed.">            return getType() == opResult.getType();</span>
        }

        @Override
        public int hashCode() {
<span class="fc" id="L95">            return getType();</span>
        }
    }

    /**
     * A result from a setData operation.  This kind of result provides access
     * to the Stat structure from the update.
     */
    public static class SetDataResult extends OpResult {
        private Stat stat;

        public SetDataResult(Stat stat) {
<span class="fc" id="L107">            super(ZooDefs.OpCode.setData);</span>
<span class="fc" id="L108">            this.stat = stat;</span>
<span class="fc" id="L109">        }</span>

        public Stat getStat() {
<span class="fc" id="L112">            return stat;</span>
        }

        @Override
        public boolean equals(Object o) {
<span class="fc bfc" id="L117" title="All 2 branches covered.">            if (this == o) return true;</span>
<span class="fc bfc" id="L118" title="All 2 branches covered.">            if (!(o instanceof SetDataResult)) return false;</span>

<span class="fc" id="L120">            SetDataResult other = (SetDataResult) o;</span>
<span class="pc bpc" id="L121" title="1 of 4 branches missed.">            return getType() == other.getType() &amp;&amp; stat.getMzxid() == other.stat.getMzxid();</span>
        }

        @Override
        public int hashCode() {
<span class="fc" id="L126">            return (int) (getType() * 35 + stat.getMzxid());</span>
        }
    }

    /**
     * A result from a version check operation.  No special values are available.
     */
    public static class CheckResult extends OpResult {
        public CheckResult() {
<span class="fc" id="L135">            super(ZooDefs.OpCode.check);</span>
<span class="fc" id="L136">        }</span>

        @Override
        public boolean equals(Object o) {
<span class="fc bfc" id="L140" title="All 2 branches covered.">            if (this == o) return true;</span>
<span class="fc bfc" id="L141" title="All 2 branches covered.">            if (!(o instanceof CheckResult)) return false;</span>

<span class="fc" id="L143">            CheckResult other = (CheckResult) o;</span>
<span class="pc bpc" id="L144" title="1 of 2 branches missed.">            return getType() == other.getType();</span>
        }

        @Override
        public int hashCode() {
<span class="fc" id="L149">            return getType();</span>
        }
    }

    /**
     * An error result from any kind of operation.  The point of error results
     * is that they contain an error code which helps understand what happened.
     * @see KeeperException.Code
     *
     */
    public static class ErrorResult extends OpResult {
        private int err;

        public ErrorResult(int err) {
<span class="fc" id="L163">            super(ZooDefs.OpCode.error);</span>
<span class="fc" id="L164">            this.err = err;</span>
<span class="fc" id="L165">        }</span>

        public int getErr() {
<span class="fc" id="L168">            return err;</span>
        }

        @Override
        public boolean equals(Object o) {
<span class="fc bfc" id="L173" title="All 2 branches covered.">            if (this == o) return true;</span>
<span class="fc bfc" id="L174" title="All 2 branches covered.">            if (!(o instanceof ErrorResult)) return false;</span>

<span class="fc" id="L176">            ErrorResult other = (ErrorResult) o;</span>
<span class="pc bpc" id="L177" title="1 of 4 branches missed.">            return getType() == other.getType() &amp;&amp; err == other.getErr();</span>
        }

        @Override
        public int hashCode() {
<span class="fc" id="L182">            return getType() * 35 + err;</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>